local function K_MomentumAngleEx(mo, threshold)
	if (FixedHypot(mo.momx, mo.momy) > threshold) then
		return R_PointToAngle2(0, 0, mo.momx, mo.momy)
	else
		return mo.angle
	end
end

local function K_MomentumAngle(mo)
	return K_MomentumAngleEx(mo, 6*mo.scale)
end

local function K_AirFailsafe(p)
	if not (p.mo and p.mo.valid) then return end

	local maxSpeed = 6*p.mo.scale
	local thrustSpeed = 6*p.mo.scale // 10*p.mo.scale

	if (p.speed > maxSpeed // Above the max speed that you're allowed to use this technique.
		or p.kartstuff[k_respawn])
		return
	end

	// Maps with "drop-in" POSITION areas cause problems if we allow failsafe.
	if (leveltime < 236)
		return
	end

	//Failsafe kicker doesn't proc until you let go
	if not (p.cmd.buttons & BT_ACCELERATE)
	and p.oldAccelInput
	and not P_IsObjectOnGround(p.mo)
	and not (p.kartstuff[k_spinouttimer] or p.kartstuff[k_squishedtimer]) then
		// Push the player forward
		P_Thrust(p.mo, K_MomentumAngle(p.mo), thrustSpeed)
		
		S_StartSound(p.mo, sfx_s23c)
		local flame = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_BOOSTFLAME)
		flame.target = p.mo
		flame.color = SKINCOLOR_WHITE
		flame.colorized = true
		flame.fuse = TICRATE/2
	end

	p.oldAccelInput = p.cmd.buttons & BT_ACCELERATE
end
addHook("PlayerThink", K_AirFailsafe)