-- Yes, I'm going out of my way to reverse engineer P_SpawnMobjFromMobj
-- since that doesn't fucking exist in 2.1/Kart afaik. Bear with me because
-- I'm too lazy to condense all this shit.
freeslot(
	"SPR_GRWP",
	"S_GROWPARTICLE"
)
states[S_GROWPARTICLE] = {SPR_GRWP, FF_FULLBRIGHT|FF_ANIMATE|A, -1, nil, 7, 1, S_GROWPARTICLE}

rawset(_G, "P_GetMobjZMovement", function(mo)
	local slope = mo.standingslope
	local angDiff
	local speed

	if not P_IsObjectOnGround(mo) then
		return mo.momz
	end

	if not slope then
		return 0
	end

	angDiff = R_PointToAngle2(0, 0, mo.momx, mo.momy) - slope.xydirection
	speed = FixedHypot(mo.momx, mo.momy)

	return P_ReturnThrustY(mo, slope.zangle, P_ReturnThrustX(mo, angDiff, speed))
end)

//
// P_ScaleFromMap
// Scales a number relative to the mapobjectscale.
//
local function P_ScaleFromMap(n, scale)
	return FixedMul(n, FixedDiv(scale, mapobjectscale))
end

//
// P_SpawnMobjFromMobjUnscaled
// Spawns an object with offsets relative to the position of another object.
// Scale, gravity flip, etc. is taken into account automatically.
//
local function P_SpawnMobjFromMobjUnscaled(mo, xofs, yofs, zofs, type)

	local newmobj

	newmobj = P_SpawnMobj(mo.x + xofs, mo.y + yofs, mo.z + zofs, type)
	if not newmobj then
		return
	end

	newmobj.destscale = P_ScaleFromMap(mo.destscale, newmobj.destscale)
	P_SetScale(newmobj, P_ScaleFromMap(mo.scale, newmobj.scale))

	if (mo.eflags & MFE_VERTICALFLIP)
		newmobj.eflags = $|MFE_VERTICALFLIP
		newmobj.flags2 = $|MF2_OBJECTFLIP
		newmobj.z = mo.z + mo.height - zofs - newmobj.height
	end

	return newmobj
end

//
// P_SpawnMobjFromMobj
// Spawns an object with offsets relative to the position of another object.
// Scale, gravity flip, etc. is taken into account automatically.
// The offsets are automatically scaled by source object's scale.
//
rawset(_G, "P_SpawnMobjFromMobj", function(mo, xofs, yofs, zofs, type)

	xofs = FixedMul(xofs, mo.scale)
	yofs = FixedMul(yofs, mo.scale)
	zofs = FixedMul(zofs, mo.scale)

	return P_SpawnMobjFromMobjUnscaled(mo, xofs, yofs, zofs, type)
end)

local function K_SpawnGrowShrinkParticles(mo, timer)
	local shrink = (timer < 0)
	local maxTime = (10*TICRATE)
	local noTime = (2*TICRATE)
	local spawnFreq = 1
	local particle = NULL
	local particleScale = FRACUNIT
	local particleSpeed = 0

	spawnFreq = abs(timer)

	if (spawnFreq < noTime)
		return
	end

	spawnFreq = $ - noTime

	if (spawnFreq > maxTime)
		spawnFreq = maxTime
	end

	spawnFreq = (maxTime - spawnFreq) / TICRATE / 4

	if (spawnFreq == 0) then
		spawnFreq = $ + 1
	end

	if (leveltime % spawnFreq) then
		return
	end
	
	local shrinkadjust = shrink and 48 or 0
	particle = P_SpawnMobjFromMobj(
		mo,
		P_RandomRange(-32, 32) * FRACUNIT,
		P_RandomRange(-32, 32) * FRACUNIT,
		(P_RandomRange(0, 24) + (shrinkadjust)) * FRACUNIT,
		MT_THOK
	)
	particle.state = S_GROWPARTICLE
	particle.target = mo
	particle.fuse = 8
	particle.momx = mo.momx
	particle.momy = mo.momy
	particle.momz = P_GetMobjZMovement(mo)

	K_MatchGenericExtraFlags(particle, mo)

	particleScale = 3*mo.scale/4
	particleSpeed = mo.scale * 4 * P_MobjFlip(mo) // NOT particleScale

	particle.destscale = particleScale
	P_SetScale(particle, particle.destscale)

	if (shrink == true)
		particle.eflags = $|MFE_VERTICALFLIP
		particle.color = SKINCOLOR_KETCHUP
		particle.momz = $ - particleSpeed
	else
		particle.color = HugeQuest and SKINCOLOR_THUNDER or SKINCOLOR_SAPPHIRE
		particle.momz = $ + particleSpeed
	end
end

addHook("PlayerThink", function(p)
	if p.spectator then return end
	
	if (p.growshrinktimer ~= 0) then
		K_SpawnGrowShrinkParticles(p.mo, p.growshrinktimer)
	end
end)

local function GrowVisuals(mo)
	if not (mo and mo.valid) then return end
	if mo.state ~= S_GROWPARTICLE then return end
	
	if (leveltime & 1) then
		--mo.flags2 = $ | MF2_DONTDRAW
	else
		mo.flags2 = $ & ~MF2_DONTDRAW
	end
end
--addHook("MobjThinker", GrowVisuals, MT_THOK)