local SLIPTIDEHANDLING = 7*FRACUNIT/8

local function K_Sliptiding(p)
	return (p.kartstuff[k_aizdriftstrat] and not p.kartstuff[k_drift])
end

local function P_CanSliptide(p)
	return ((p.handleboost >= SLIPTIDEHANDLING) or (p.kartstuff[k_sneakertimer] > 0))
end

local function rescale(value, oldmin, oldmax, newmin, newmax)
    return newmin +  FixedMul(FixedDiv( value-oldmin , oldmax-oldmin), newmax-newmin)
end

local function P_UpdatePlayerAngle(mo)
	if leveltime < 3 then return end
	if not (mo and mo.valid and mo.player) then return end
	
	local p = mo.player
	local turninput = p.cmd.driftturn

	-- variables for stat calculations.
	local sp = p.kartspeed
	local ac = 9 - sp
	local we = p.kartweight
	local ha = 9 - we
			
	-- speed.
	local g_cc = 56320 + (12288 * gamespeed)
	local shiftby = 14
	local truespeed = FixedMul((150 + sp*3)<<shiftby, g_cc)
			
	-- used for handling calculations.
	local onground = P_IsObjectOnGround(p.mo)
			
	-- for drift handling.
	local function RR_GetKartDriftValue(countersteer, handling)
		if ((p.kartstuff[k_drift] == 0) or (not onground))
			return 0
		elseif (p.kartstuff[k_driftend] != 0)
			return -266*p.kartstuff[k_drift]
		else
			local driftweight = (9-handling)*14
			local basedrift = 83*p.kartstuff[k_drift] - (driftweight - 14)*p.kartstuff[k_drift]/5
			local driftangle = abs((252 - driftweight)*p.kartstuff[k_drift]/5)
			return basedrift + FixedMul(driftangle, countersteer)
		end
	end
			
	-- handling. sweet jesus.		
	local function RR_GetKartTurnValue(t, weight)
			
		local p_maxspeed = FixedMul(truespeed, 6*FRACUNIT)
		local adjustangle = FixedDiv((p_maxspeed>>FRACBITS) - (p.speed>>FRACBITS), (p_maxspeed/2>>FRACBITS) + (10-weight))
		
		--if K_Sliptiding(p) then
			--adjustangle = $*2
		--end
				
		if (p.kartstuff[k_drift] != 0 and onground)
			if (p.kartstuff[k_driftend] == 0)
				local countersteer = FixedDiv(turninput*FRACUNIT, 800*FRACUNIT)
				t = RR_GetKartDriftValue(countersteer, ha)
			else
				t = $ + RR_GetKartDriftValue(FRACUNIT, ha)
			end
		end
				
		local finalhandleboost = 0

		// You need turning power proportional to your speed, no matter what!
		local topspeed = K_GetKartSpeed(p, false)
		
		-- Let's see if we can force sliptiding here
		local dturn = (p.cmd.driftturn > 0)
		local sturn = (p.cmd.driftturn < 0)
		if P_CanSliptide(p)
		and ((((p.cmd.driftturn > 0 and p.LFdrift > 0) or (p.cmd.driftturn < 0 and p.LFdrift < 0))
		and p.kartstuff[k_jmp] < p.LFdriftinput)
		or ((p.LFAIZ > 0 and p.cmd.driftturn > 0) or (p.LFAIZ < 0 and p.cmd.driftturn < 0)))
		and P_IsObjectOnGround(p.mo) then -- Fucking hell lmao
			--print("Fuuuuuck")
			if dturn then
				p.fakeAIZ = 1
			elseif sturn then
				p.fakeAIZ = -1
			end
		elseif (not p.cmd.driftturn or p.kartstuff[k_drift]
		or (p.cmd.driftturn > 0 and p.LFturn <= 0)
		or (p.cmd.driftturn < 0 and p.LFturn >= 0)) then
			p.fakeAIZ = 0
		end
		
		

		p.kartstuff[k_aizdriftstrat] = p.fakeAIZ

		if (K_Sliptiding(p)) then
			finalhandleboost = FixedMul(5*SLIPTIDEHANDLING/2, FixedDiv(p.speed, topspeed))
		end

		if (finalhandleboost > 0 and not p.kartstuff[k_respawn]) then
			adjustangle = FixedMul(adjustangle, FRACUNIT + finalhandleboost)
		end
				
		t = FixedMul($, adjustangle)
		if p.handleboost then
			t = FixedMul($, (FRACUNIT + p.handleboost))
		else
			if (p.kartstuff[k_invincibilitytimer] or p.kartstuff[k_sneakertimer] or p.kartstuff[k_growshrinktimer] or (HugeQuest and p.hugequest.huge > 0))
				t = FixedMul($, FixedDiv(15*FRACUNIT, 8*FRACUNIT))
			end
		end
		return t
	end
	local trueturning = RR_GetKartTurnValue(turninput, ha)
			
	if(abs(p.speed) > 0)
		p.cmd.angleturn = $ + (trueturning<<20)
		--print("Angle Change: "..(desiredturning<<20))
		--print("Angle Conversion: "..FixedAngle((desiredturning<<20)))
		--print("Final Angle? "..FixedAngle((desiredturning<<20))/ANG1)
		if K_Sliptiding(p)
		and P_IsObjectOnGround(p.mo) -- Air sliptiding? Ehhhh, no thanks.

			-- 8 weight strikes a balance where you can sliptide at high speed
			-- while maintaining a solid level of control.
			-- So let's use 1 handling!
			local desiredturning = RR_GetKartTurnValue(turninput, 1)

			-- Then we calculate how long it would take to apply the full value 
			-- of the above.
			-- Smaller scalars mean sharper sliptides.
			local angleScalar = rescale(p.kartweight*FRACUNIT, FRACUNIT, 9*FRACUNIT, 6*TICRATE, 8*TICRATE)
			P_Thrust(p.mo, p.mo.angle + ((desiredturning<<20)/angleScalar), 1)
			--p.mo.angle = $ + ((desiredturning<<20)/angleScalar)

			-- This is where illegal shit becomes possible :malicious:
			-- Seriously though, base game makes sliptiding useless if
			-- you try to do it near the end of a boost, since sliptiding
			-- REQUIRES an active boost to work. With this, you can use your
			-- sliptide whenever, and you'll maintain a boost state so long as
			-- you're committing to the turn.
			p.kartstuff[k_sneakertimer] = max($, 1)
		end
		--print("D. Turning: "..(desiredturning<<20))
		--print("Angle Turn: "..p.cmd.angleturn)
	end
end

local function RR_Handling(mo)
	if not (mo and mo.valid and mo.player) then return end
	if leveltime < 3 then return end

	P_UpdatePlayerAngle(mo)
	
	mo.player.LFdriftinput = mo.player.kartstuff[k_jmp]
	mo.player.LFdrift = mo.player.kartstuff[k_drift]
	mo.player.LFAIZ = mo.player.kartstuff[k_aizdriftstrat]
	mo.player.LFturn = mo.player.cmd.driftturn
end

addHook("MobjThinker", RR_Handling, MT_PLAYER)