-- Triangle Dash, from Ring Racers

local FRACUNIT = FRACUNIT
local TICRATE = TICRATE

local cv_tridash = CV_RegisterVar({
    name = "rr_tridash",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR
})

local function K_MomentumAngleEx(mo, threshold)
	if (FixedHypot(mo.momx, mo.momy) > threshold) then
		return R_PointToAngle2(0, 0, mo.momx, mo.momy)
	else
		return mo.angle
	end
end

local function K_MomentumAngle(mo)
	return K_MomentumAngleEx(mo, 6*mo.scale)
end

local function IsPlayerHurt(p)
	if p.kartstuff[k_spinouttimer]
	or p.kartstuff[k_squishedtimer]
	or p.playerstate == PST_DEAD
	or p.playerstate == PST_RESPAWN
	or p.kartstuff[k_respawn]
		return true
	end
	return false
end

local driftspark = {
	S_DRIFTSPARK_A1,
	S_DRIFTSPARK_A2,
	S_DRIFTSPARK_A3,
	S_DRIFTSPARK_B1,
	S_DRIFTSPARK_C1,
	S_DRIFTSPARK_C2
}

local function RR_SpawnDriftSparks(p)
	if not (p.mo and p.mo.valid) then return end
	
	local newx
	local newy
	local spark
	local travelangle
	
	if leveltime %2 == 1 then
		return
	end
	
	travelangle = p.mo.angle - (ANGLE_45/5)*p.kartstuff[k_drift]
	
	newx = p.mo.x + P_ReturnThrustX(p.mo, travelangle + (ANGLE_180), FixedMul(32*FRACUNIT, p.mo.scale))
	newy = p.mo.y + P_ReturnThrustY(p.mo, travelangle + (ANGLE_180), FixedMul(32*FRACUNIT, p.mo.scale))
	spark = P_SpawnMobj(newx, newy, p.mo.z, MT_DRIFTSPARK)
		
	spark.target = p.mo
	spark.angle = travelangle-(ANGLE_45/5)*p.kartstuff[k_drift]
		
	spark.scale = p.mo.scale
	--P_SetScale(spark, p.mo.scale)
		
	spark.momx = p.mo.momx/2
	spark.momy = p.mo.momy/2
	
	if p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)*4 then
		spark.color = (1 + (leveltime % (MAXSKINCOLORS-1)))
	elseif p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)*3 then
		if p.kartstuff[k_driftcharge] <= (K_GetKartDriftSparkValue(p)*3)+(24*3) then
			spark.color = SKINCOLOR_BLUE
		else
			spark.color = SKINCOLOR_SAPPHIRE
		end
	elseif p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)*2 then
		if p.kartstuff[k_driftcharge] <= (K_GetKartDriftSparkValue(p)*2)+(24*3) then
			spark.color = SKINCOLOR_RASPBERRY -- transition
		else
			spark.color = SKINCOLOR_KETCHUP
        end
	else
		spark.color = SKINCOLOR_YELLOW
    end

	if (p.kartstuff[k_drift] > 0 and p.cmd.driftturn > 0) -- Inward drifts
	or (p.kartstuff[k_drift] < 0 and p.cmd.driftturn < 0) then

		if p.kartstuff[k_drift] < 0 and (i & 1)
		or (p.kartstuff[k_drift] > 0 and !(i & 1)) then

			spark.state = S_DRIFTSPARK_A1
		elseif (p.kartstuff[k_drift] < 0 and !(i & 1))
		or (p.kartstuff[k_drift] > 0 and (i & 1)) then

			spark.state = S_DRIFTSPARK_C1
		end
	elseif (p.kartstuff[k_drift] > 0 and p.cmd.driftturn < 0) -- Outward drifts
		or (p.kartstuff[k_drift] < 0 and p.cmd.driftturn > 0) then

		if (p.kartstuff[k_drift] < 0 and (i & 1))
		or (p.kartstuff[k_drift] > 0 and !(i & 1)) then
			spark.state = S_DRIFTSPARK_C1
		elseif (p.kartstuff[k_drift] < 0 and !(i & 1))
			or (p.kartstuff[k_drift] > 0 and (i & 1)) then

			spark.state = S_DRIFTSPARK_A1
        end
    end
		
	K_MatchGenericExtraFlags(spark, p.mo)
end

local function RR_MoveInit(p)
	p.RRoldDriftCharge = 0
	p.RRoldDriftBoost = 0
	p.RRoldBounce = 0
	p.RRoldButtons = 0
	p.RRstrongDriftBoost = 0
	p.RRfastfall = 0
	p.RRfastfallBase = 0
	p.RRcanFastfall = true
	p.RRoldSpeed = 0
end
addHook("PlayerSpawn", RR_MoveInit)

local function RR_Movement(p)
	local onground = P_IsObjectOnGround(p.mo)
	
	/*
	if not onground then
		if (p.RRoldSpeed ~= nil) then
			if p.speed >= 75*mapobjectscale then
				p.speed = p.RRoldSpeed - ((p.RRoldSpeed/50)/TICRATE)
				
				local topspeed = K_GetKartSpeed(p, true)
				local newMagnitude = R_PointToDist2(p.mo.momx - p.cmomx, p.mo.momy - p.cmomy, 0, 0)
				if (newMagnitude > topspeed)
					local tempmomx, tempmomy
					tempmomx = FixedMul(FixedDiv(p.mo.momx - p.cmomx, newMagnitude), topspeed)
					tempmomy = FixedMul(FixedDiv(p.mo.momy - p.cmomy, newMagnitude), topspeed)
					p.mo.momx = tempmomx + p.cmomx
					p.mo.momy = tempmomy + p.cmomy
				end
			end
		end
	end
	*/

	if p.RRstrongDriftBoost then
		p.RRstrongDriftBoost = $-1
	end

	if p.RRoldDriftBoost ~= nil then
		
		if not onground and p.kartstuff[k_driftcharge] > K_GetKartDriftSparkValue(p) then
			RR_SpawnDriftSparks(p)
		end
		
		if ((p.RRoldDriftCharge > p.kartstuff[k_driftcharge])
		or (not (p.cmd.buttons & BT_DRIFT) and (not P_IsObjectOnGround(p.mo)) and (p.RRoldDriftCharge == p.kartstuff[k_driftcharge])))
		and not IsPlayerHurt(p) then
			local pushdir = K_MomentumAngle(p.mo)
			local oldDriftBooster = p.kartstuff[k_driftboost]
		
			local target = K_GetKartDriftSparkValue(p) -- Taken from source.
			local LDC = p.RRoldDriftCharge
			
			if p.RRoldBounce then
				return
			elseif p.speed <= 10*FRACUNIT then
				return
			elseif IsPlayerHurt(p) then
				return
			elseif LDC < target then
				return
			elseif p.RRoldButtons and (p.cmd.buttons & BT_DRIFT)
				return
			else
				if not onground
				and cv_tridash.value then
					-- Increasing this from RR's version because you're not
					-- constantly at breakneck speed, so p.speed/2 isn't
					-- enough downforce to be effective in Kart.
					p.mo.momz = $ - (3*(p.speed)/2)
					--print("Drop!")
				end
			
				if LDC >= target*4 then -- Rainbow and red MT values taken from source.
					if not onground
					and cv_tridash.value then
						P_Thrust(p.mo, pushdir, 5*p.speed/4)
					end
			
					p.kartstuff[k_driftboost] = max($, 125)
					p.RRstrongDriftBoost = 125
				elseif LDC >= target*3 then -- Yep, we're doing this lmao
					if not onground 
					and cv_tridash.value then
						P_Thrust(p.mo, pushdir, p.speed)
					end
			
					p.kartstuff[k_driftboost] = max($, 85)
					p.RRstrongDriftBoost = 85
				elseif LDC >= target*2 then
					if not onground 
					and cv_tridash.value then
						P_Thrust(p.mo, pushdir, p.speed/2)
					end
					p.kartstuff[k_driftboost] = max($, 50)
				elseif LDC >= target then
					if not onground
					and cv_tridash.value then
						P_Thrust(p.mo, pushdir, p.speed/3)
					end
					p.kartstuff[k_driftboost] = max($, 20)
				end
			end
	
			-- A small piece of the larger puzzle that is this potential project
			if (p.kartstuff[k_driftboost] > oldDriftBooster)
				p.kartstuff[k_driftboost] = (38 + p.kartweight + p.kartspeed) * p.kartstuff[k_driftboost] / 40
				
				local driftLvl = 1	
				if p.RRoldDriftCharge >= target*4 then --rainbow
					driftLvl = 4
				elseif p.RRoldDriftCharge >= target*3 then
					driftLvl = 3
				elseif p.RRoldDriftCharge >= target*2 then --red
					driftLvl = 2
				end
			end
			
			if not onground
			and cv_tridash.value then
				S_StartSound(p.mo, sfx_s23c)
			end
			
			if cv_tridash.value then
				p.kartstuff[k_driftcharge] = 0
			end
			
			if not SpeedLib.running then
				if p.RRstrongDriftBoost then
					p.kartstuff[k_speedboost] = max($, FRACUNIT/3)
				end
			end
		end
	end
	--print("Drift Charge Check 2: "..p.kartstuff[k_driftcharge])
end
addHook("ThinkFrame", function()
	if leveltime == 0 then return end
	
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		
		--print("Drift Charge Check 1: "..p.kartstuff[k_driftcharge])
		RR_Movement(p)
		
		p.RRoldDriftBoost = p.kartstuff[k_driftboost]
		p.RRoldDriftCharge = p.kartstuff[k_driftcharge]
		p.RRoldButtons = p.cmd.buttons & BT_DRIFT
		p.RRoldBounce = p.mo.eflags & MFE_JUSTBOUNCEDWALL
		p.RRoldSpeed = p.speed
		--print("Old Drift Charge: "..p.RRoldDriftCharge)
		--print("Drift Charge Check 3: "..p.kartstuff[k_driftcharge])
	end
end)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid and mo.target.player) then return end
	
	local p = mo.target.player
	p.RRTierThree = $ or 0
	
	if p.RRGrowtics then
		p.RRGrowtics = $-1
	end

	if p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)*3
	and p.kartstuff[k_driftcharge] < K_GetKartDriftSparkValue(p)*4 then
		if not p.RRTierThree then
			S_StartSoundAtVolume(p.mo, sfx_s3ka2, 192)
			p.RRGrowtics = 8
		end

		if p.kartstuff[k_driftcharge] <= (K_GetKartDriftSparkValue(p)*3)+(24*3) then
			mo.color = SKINCOLOR_BLUE
		else
			mo.color = SKINCOLOR_SAPPHIRE
		end
		
		local extraScale = 0
		
		if p.RRGrowtics then
			local pulse = CV_FindVar("driftsparkpulse").value or 7*FRACUNIT/5
			extraScale = FixedDiv(p.RRGrowtics*FRACUNIT, 8*FRACUNIT)
			
			mo.scale = FixedMul(mo.target.scale, FRACUNIT + FixedMul(extraScale, pulse))
		else
			mo.scale = mo.target.scale
		end
	elseif p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)
	and p.kartstuff[k_driftcharge] < K_GetKartDriftSparkValue(p)*2
		mo.color = SKINCOLOR_YELLOW
	end
	
	p.RRTierThree = (p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)*3)
end, MT_DRIFTSPARK)